#include <stdio.h>
#include <stdlib.h>

unsigned short calc_crc(unsigned char* buf, int buf_len)
{
    unsigned short crc = ~0;
    int i, j;
    for (i = 0; i < buf_len; ++i) {
        crc ^= buf[i];
        for (j = 0; j < 8; ++j) {
            if (crc & 1) crc = (crc >> 1) ^ 0x8408;
            else         crc =  crc >> 1;
        }
    }
    return (((crc >> 8) & 255) << 0) | (((crc >> 0) & 255) << 8);
}

int main(void)
{
    int i;
    int state;
    int val;
    char c;
    unsigned char* line = NULL; int line_cap = 0; int line_len;
    unsigned char* data = NULL; int data_cap = 0; int data_len;

    while (1) {
        line_len = getline(&line, &line_cap, stdin);

        if (line_len == -1) {
            if (feof(stdin)) {
                return EXIT_SUCCESS;
            } else {
                perror("getline");
                return EXIT_FAILURE;
            }
        }

        if (line_len / 2 > data_cap) {
            data_cap = line_len / 2;
            data = realloc(data, data_cap);
        }

        state = val = data_len = 0;
        for (i = 0; i < line_len; ++i) {
            c = line[i];
            switch (c) {
            case 'a' ... 'f': val = (val * 16) | (c - 'a' + 10); break;
            case 'A' ... 'F': val = (val * 16) | (c - 'A' + 10); break;
            case '0' ... '9': val = (val * 16) | (c - '0' +  0); break;
            default: continue;
            }
            ++state;
            if (state == 2) {
                data[data_len] = val;
                state = val = 0;
                ++data_len;
            }
        }

        printf("%04x\n", calc_crc(data, data_len));
    }
}

/* vim: set ts=4 sts=4 sw=4 tw=80 et: */
