/* lib/misc.h
 *
 * Miscellaneous macros and junk.
 *
 * Copyright (C) 2003, 2004
 * Zorica Majdov <zmajdov@virtuoso.com>
 * Andy Goth     <unununium@openverse.com>
 *
 * This code is available under the GNU General Public License; see COPYING. */

#ifndef SEEN_LIB_MISC_H
#define SEEN_LIB_MISC_H

#include "error.h"

/* A silly little exception handling system. */
#define try          do { if ((ret = ({
#define catch(label) })) < E_OK) goto label; } while (0)

/* Evaluates to the lesser of the two operands. */
#define MIN(a, b) ({typeof(a) _a = (a); typeof(b) _b = (b); \
                    _a < _b ? _a : _b;})

/* Evaluates to the greater of the two operands. */
#define MAX(a, b) ({typeof(a) _a = (a); typeof(b) _b = (b); \
                    _a > _b ? _a : _b;})

/* Evaluates to the number of elements in an array. */
#define LEN(x) (sizeof(x) / sizeof(*(x)))

/* If 'x' is positive, 1.  If 'x' is negative, -1.  If 'x' is zero, 0. */
#define SGN(x) ({typeof(x) _x = (x); _x < 0 ? -1 : _x > 0 ? 1 : 0;})

#endif

/* ======================================================================== */

/* vim: set ts=4 sts=4 sw=4 tw=80 et: */
/* EOF */
